let jcfw = require('./jcfw');
let jcshare = jcfw.share;

let SDKManage = function() {
  // this.isoffical = global.env === 'product';
  // this.isoffical = global.env === 'product';
  this.isoffical = true
  this.gameId = 8007;
  this.hasLogin = false;
  this.vision = '1.0.0';
  //#ifdef MP-WEIXIN
  this.channelId = 6001;
  // #endif
  //#ifdef H5
  this.channelId = 6000;
  // #endif
  this.shareAchieveId = global.shareAchieveId;
  this.mpCode = '';
  this.init = async function(launchObj) {
    this.launchObj = launchObj;
    jcfw.init(this.channelId, this.gameId, this.isoffical, launchObj);
    // redis 配置
    await this.getGameConfig();
  };
  this.updateMpCode = function(mpCode) {
    this.mpCode = mpCode;
  };
  this.login = async function(cb) {
    await this.gameLogin();
    await this.checkShareData();
    // 获取分享配置
    await this.getShareConfig();
  };
  this.gameLogin = () => {
    let self = this;
    let loginCount = 0;
    return new Promise((resolve, reject) => {
      let login = () => {
        let token = wx.getStorageSync('token');
        if (!token) {
          token = jcfw.makeUUID();
          try {
            wx.setStorageSync('token', token);
          } catch (e) {
          }
        }
        jcfw.loginUser((res) => {
            self.hasLogin = true;
            console.log('login success', res);
            wx.setStorageSync('account', res);
            self.account_id = res.account_id;
            resolve();
          },
          (neterr, logicerr, errmsg) => {
            if (loginCount++ < 10) {
              login();
            } else {
              reject();
            }
          },
          self.mpCode
        );
      };
      login();
    });
  };
  // 从app启动参数中获取分享者信息
  this.checkShareData = function() {
    return new Promise((resolve, reject) => {
      let ldata;
      if (this.launchObj) {
        ldata = this.launchObj.query;
      } else {
        ldata = wx.getLaunchOptionsSync().query;
      }
      if (ldata.inviter_id) {
        jcshare.acceptAchievementInvite(ldata.inviter_id, this.shareAchieveId, JSON.stringify([['100', 100]]));
      }
      resolve();
    });


  };
  // 获取服务端游戏配置
  this.getGameConfig = function() {
    let tryCount = 0;
    return new Promise((resolve, reject) => {
      let cb = function(res) {
        console.log('getGameConfig', res);
        wx.setStorageSync('cfg', res);
        if (res.game_types) {
          try {
            global.gameTypes = JSON.parse(res.game_types);
          } catch (err) {
            console.log('parse game types error');
          }
        }
        if (res.languages) {
          try {
            global.languages = JSON.parse(res.languages);
            global.languages.unshift('所有语言');
          } catch (err) {
            console.log('parse languages error');
          }
        }

        if (res.categorys) {
          try {
            global.categorys = JSON.parse(res.categorys);
            global.categorys.unshift('所有');
          } catch (err) {
            console.log('parse categorys error');
          }
        }

        resolve();
      };
      let cbf = function(res) {
        console.log('getGameConfig fail');
        if (tryCount++ < 10) {
          request();
        } else {
          reject();
        }
      };
      let request = () => {
        jcfw.cloud.initConfig(cb, cbf);
      };
      request();
    });
  };


  this.setStorage = function(v, successcb, failcb) {
    if (this.hasLogin) {
      jcfw.cloud.setStorages(v, successcb, failcb);
    }
  };
  this.getStorage = function(keys, successcb, failcb) {
    if (this.hasLogin) {
      jcfw.cloud.getStorages(keys, successcb, failcb);
    }
  };
  // 获取服务端分享配置
  this.getShareConfig = function() {
    let tryCount = 0;
    return new Promise((resolve, reject) => {
      let cbs = function(res) {
        if (res.length > 0) {
          let shareArr = {};
          for (let obj of res) {
            shareArr[obj.type] = {image: obj.image, str: obj.str}
          }
          wx.setStorageSync('share_cfg', shareArr);
        }
        console.log('getShareConfig success', res);
        resolve();
      };
      let cbf = function() {
        console.log('getShareConfig fail');
        if (tryCount++ < 10) {
          request();
        } else {
          reject();
        }
      };
      let request = () => {
        jcfw.cloud.getShareData(this.sex, this.province, this.city, cbs, cbf);
      };
      request();
    });
  };
  /**
   * 获取成就分享人数
   * 游戏分享 100
   * 电影分享 101
   * */
  this.getAchieveInviteeNum = function() {
    let self = this;
    return new Promise((resolve, reject) => {
      const callback = function(res) {
        console.log('playerData.invitee_nums', res);
        let invitee_nums = 0;
        for (let i = 0; i < res.length; i++) {
          if (res[i].achievement_id == self.shareAchieveId) {
            invitee_nums = res[i].invitee_num;//邀请玩家数
            break;
          }
        }
        resolve(invitee_nums);
      };
      jcshare.getAchievInviteeNum(callback, (err) => {
        reject(err);
      });
    });
  };

  /**
   * 获取成就分享详情
   * 游戏分享 100
   * 电影分享 101
   * */
  this.queryAchievementShareDetail = function() {
    let self = this;
    return new Promise((resolve, reject) => {
      const callback = function(res) {
        const result = res[parseInt(self.shareAchieveId)] || [];
        resolve(result);
      };
      jcshare.queryAchievementShareDetail([parseInt(self.shareAchieveId)], callback, function() {
        reject();
      });
    });
  };
  /**
   * 更新用户微信资料
   * @param {Object} allInfo 为bindGetUserInfo(e)中 e.detail，不是e.detail.userInfo
   * */
  this.updateUser = function(allInfo) {
    return new Promise((resolve, reject) => {
      jcfw.updateUser(allInfo, (obj) => {
        resolve(obj);
      }, (err) => {
        reject(err);
      });
    });
  };
  /**
   * 上传日志
   * @param {String} eventName 事件名
   * @param {Object} param JSON格式的参数
   * */
  this.uploadLog = function(eventName, param) {
    jcfw.gamelog.logButtonClick(eventName, param);
  };
};


let instance = new SDKManage();
module.exports = instance;
