import {
  Action,
  getModule,
  Module,
  Mutation,
  VuexModule
} from 'vuex-module-decorators'
import store from '@/store'

export interface IUserState {
  token: string
  name: string
  avatar: string
  sex?: string
  collectSet: Set<string>
}

@Module({ dynamic: true, store, name: 'user' })
class User extends VuexModule implements IUserState {
  public avatar: string = ''
  public name: string =''
  public sex: string = ''
  public token: string = ''
  public collectSet = new Set<string>()

  @Mutation
  public SET_TOKEN(token: string) {
    this.token = token
  }
  @Action
  public add_collect(gameId: string) {
    this.collectSet.add(gameId)
  }
  @Action
  public remove_collect(gameId: string) {
    this.collectSet.delete(gameId)
  }

  @Action
  public update_collect(games: string[]) {
    games.forEach(this.collectSet.add, this.collectSet)
  }


}

export const UserModule = getModule(User)
